#!/usr/bin/ruby

require 'json'
require 'socket'
require 'date'
require 'etc'

fs=ARGV[0]

$host = Socket.gethostname

$time = Time.now.to_i

$output = []

quotas=`repquota #{fs}`

fs=fs.gsub(/\//, '_')

if fs == '_'
  fs = 'root'
end

quotas.each_line do |line|
  items = line.split(/ [ ]*/)
  begin
    info = Etc.getpwnam(items[0])
  rescue StandardError => msg
    next
  end
  next if(info.uid < 1000)
  if items[1] != '--'
    exceeded = true
  else
    exceeded = false
  end
  next if items[2].to_i < 5
  $output << { 'name'   => "quotas_#{fs}", 'host' => $host, 'time' => $time,
               'user_t' => items[0], 'size' => items[2].to_i * 1024, 'files' => items[5].to_i, 'exceeded' => exceeded}
end

f = File.new("/var/tmp/quota_stats_#{fs}.json.new", "w", 0644)
f.write(JSON.pretty_generate($output))
f.close

File.rename("/var/tmp/quota_stats_#{fs}.json.new", "/var/tmp/quota_stats_#{fs}.json")
